'===============================================================================
'*
'*  : RVN
'*  :  16.09.2019 .
'*
'*  :  ATmega8
'*    :  8 M
'*  : BASCOM-AVR 2.0.8.1
'*
'*  :  HEXAGON "ר"
'*
'===============================================================================



'-------------------     -----------------------------------

'$prog &HFF , &H44 , &HD1 , &H00                            '  . -.

$map                                                        '      Bascom
$regfile = "m8def.dat"                                      '  
$crystal = 8000000                                          '   8000000
$framesize = 128
$hwstack = 192
$swstack = 192

                    '   
'***************************************************************************************
Config Pind.2 = Input
Set Portd.2

                    '  
'***************************************************************************************
Config Timer0 = Timer , Prescale = 8 , Clear Timer = 0
On Timer0 Refresh Nosave

                    '  I2C  DS1307  DS3231
'***************************************************************************************
Config Scl = Portb.7
Config Sda = Portb.6

                    '   0
'***************************************************************************************
Enable Timer0

                    '    
'***************************************************************************************
Enable Interrupts

                    ' 
'***************************************************************************************
Dim Prev_sec As Byte                                        '  
Dim Tik_1 As Dword                                          '    1
Dim Kolzo As Byte                                           '      
Dim Temp As Byte                                            '  
Dim Tmp As Byte                                             '  
Dim Tmp1 As Byte                                            '  
Dim Tmp2 As Byte                                            '  
Dim Temp1 As Word                                           '  
Dim Temp2 As Word                                           '  
Dim Effect As Byte                                          '  
Dim Seco As Byte                                            ' 
Dim Mine As Byte                                            ' 
Dim Hour As Byte                                            ' 
Dim Weekday As Byte                                         '  
Dim Dat As Byte                                             ' 
Dim Month As Byte                                           ' 
Dim Year As Byte                                            ' 
Dim Des_hour As Byte                                        '  
Dim Ed_hour As Byte                                         '  
Dim Des_min As Byte                                         '  
Dim Ed_min As Byte                                          '  
Dim Des_sec As Byte                                         '  
Dim Ed_sec As Byte                                          '  


'     - 132                                                                              '
Dim Dat_1(12) As Byte
Dim Dat_2(12) As Byte
Dim Dat_3(12) As Byte
Dim Dat_4(12) As Byte
Dim Dat_5(12) As Byte
Dim Dat_6(12) As Byte
Dim Dat_7(12) As Byte
Dim Dat_8(12) As Byte
Dim Dat_9(12) As Byte
Dim Dat_10(12) As Byte
Dim Dat_11(12) As Byte


                     '    
'***************************************************************************************
Dim Rnd_a As Byte                                           '  
Dim Rnd_b As Byte                                           '  
Dim Rnd_c As Byte                                           '  
Rnd_a = 123 : Rnd_b = 23 : Rnd_c = 18                       ' . ,  0


                    '  
'***************************************************************************************
' 
Gosub Gettime

'        -    
'     -     -    !!! 2   - 12:00  00:00
If Seco > 59 Or Mine > 59 Or Hour > 23 Or Dat > 31 Or Month > 12 Or Year > 99 Or Pind.2 = 0 Then
   Seco = 0 : Mine = 0 : Hour = 0
   Gosub Settime
   Dat = 1 : Month = 1 : Year = 19
   Gosub Setdate
   Weekday = 3
   Gosub Week_day
End If


Readeeprom Effect , 7                                       '    
If Effect > 5 Then Effect = 0

'===============================================================================


'                                     

'===============================================================================
Do

  '==========   ==========
   If Pind.2 = 0 Then
      Incr Tik_1
   Else

      If Tik_1 > 1 And Tik_1 < 10 Then                      ' :  
         Gosub Min_plus
         Gosub Gettime
         Gosub Update_7
         Gosub Update_60
      End If

      If Tik_1 > 9 And Tik_1 < 20 Then                      ' :  
         Gosub Hour_plus
         Gosub Gettime
         Gosub Update_7
         Gosub Update_60
      End If

      If Tik_1 > 19 Then                                    '  :  
         Incr Effect
         If Effect = 6 Then Effect = 0
         Writeeeprom Effect , 7                             '    
         Gosub Update_7
         Gosub Update_60
      End If

      Tik_1 = 0
   End If


  '==========    DS ==========
   Gosub Gettime
   If Prev_sec <> Seco Then
      Prev_sec = Seco                                       '    
      Gosub Update_7                                        '  
      Gosub Update_60                                       '   
   End If

   '
   Waitms 50

   If Effect = 2 Or Effect = 5 Then Gosub Update_60         '   ,   ""


   '=====  =====
   '0 -   ,   ,  
   '1 -   ,   ,   
   '2 -   ,   ,   + ""
   '3 -   ,    (12  ),  
   '4 -   ,    (12  ),  ,   
   '5 -   ,    (12  ),   + ""

Loop
End


'==========    ==========
'***************************************************************************************
Rnd_byte:
   $asm
      Lds R16 , {Rnd_a}                                     '
      Lds R17 , {Rnd_b}
      Lds R18 , {Rnd_c}
      Mov R16 , R17                                         'A=B
      Mov R17 , R18                                         'B=C
      Lsl R17                                               'B<<1
      Brcc _Null
      Sbr R17 , 1                                           ' "1"  D1  7     "1"
_null:
      Mov R18 , R16                                         '=B+A
      Add R18 , R17                                         '-||-
      Sts {Rnd_a} , R16                                     '
      Sts {Rnd_b} , R17
      Sts {Rnd_c} , R18
   $end Asm
Return

'==========    ==========
'***************************************************************************************
Update_7:
  '=== 
   For Temp = 1 To 12
      Dat_1(temp) = 0
      Dat_2(temp) = 0
      Dat_3(temp) = 0
      Dat_4(temp) = 0
      Dat_5(temp) = 0
      Dat_6(temp) = 0
   Next Temp

   '===   -   
   '  - Dat 1,2,4
   For Temp = 1 To 12
      If Effect < 3 Then
         Temp2 = 36 * Ed_hour
      Else
         Temp2 = 36 * Ed_min
      End If
      Temp1 = Temp2 + Temp
      Temp1 = Temp1 - 1
      Dat_1(temp) = Lookup(temp1 , Ed_h)
      Temp1 = Temp1 + 12
      Dat_2(temp) = Lookup(temp1 , Ed_h)
      Temp1 = Temp1 + 12
      Dat_4(temp) = Lookup(temp1 , Ed_h)
   Next Temp

   '  - Dat 3,5,6
   For Temp = 1 To 12
      If Effect < 3 Then
         Temp2 = 36 * Des_hour
      Else
         Temp2 = 36 * Des_min
      End If
      Temp1 = Temp2 + Temp
      Temp1 = Temp1 - 1
      Dat_3(temp) = Lookup(temp1 , Des_h)
      Temp1 = Temp1 + 12
      Dat_5(temp) = Lookup(temp1 , Des_h)
      Temp1 = Temp1 + 12
      Dat_6(temp) = Lookup(temp1 , Des_h)
   Next Temp

Return

'==========     ==========
'***************************************************************************************
Update_60:
   '=== 
   For Temp = 1 To 12
      Dat_7(temp) = 0
      Dat_8(temp) = 0
      Dat_9(temp) = 0
      Dat_10(temp) = 0
      Dat_11(temp) = 0
   Next Temp

   '===   -        
   If Effect < 3 Then
        '
      If Mine <> 0 Then
         Temp = Mine + 1
         Tmp = Temp \ 12
         Tmp1 = Tmp * 12
         Tmp2 = Temp - Tmp1


         If Tmp = 0 Then
            For Temp = 2 To Tmp2
               Dat_9(temp) = 1
            Next Temp
         End If
         If Tmp = 1 Then
            For Temp = 2 To 12
               Dat_9(temp) = 1
            Next Temp
            For Temp = 1 To Tmp2
               Dat_11(temp) = 1
            Next Temp
         End If
         If Tmp = 2 Then
            For Temp = 1 To 12
               If Temp <> 1 Then Dat_9(temp) = 1
               Dat_11(temp) = 1
            Next Temp
            For Temp = 1 To Tmp2
               Dat_10(temp) = 1
            Next Temp
         End If
         If Tmp = 3 Then
            For Temp = 1 To 12
               If Temp <> 1 Then Dat_9(temp) = 1
               Dat_11(temp) = 1
               Dat_10(temp) = 1
            Next Temp
            For Temp = 1 To Tmp2
               Dat_8(temp) = 1
            Next Temp
         End If
         If Tmp = 4 Then
            For Temp = 1 To 12
               If Temp <> 1 Then Dat_9(temp) = 1
               Dat_11(temp) = 1
               Dat_10(temp) = 1
               Dat_8(temp) = 1
            Next Temp
            For Temp = 1 To Tmp2
               Dat_7(temp) = 1
            Next Temp
         End If
         If Tmp = 5 Then
            For Temp = 1 To 12
               If Temp <> 1 Then Dat_9(temp) = 1
               Dat_11(temp) = 1
               Dat_10(temp) = 1
               Dat_8(temp) = 1
               Dat_7(temp) = 1
            Next Temp
         End If
      End If

      '
      If Effect = 1 Then
         Gosub Video_seco
      End If

   Else
      '
      If Effect = 4 Then
         Gosub Video_seco
      End If

      '12  
      If Hour > 11 Then
         Temp = Hour - 12
      Else
         Temp = Hour
      End If
      If Temp = 0 Then Temp = 12

      '
      If Temp > 0 Then
         'Dat_9(4) = 1
         Dat_9(5) = 1
         Dat_9(6) = 1
         Dat_9(7) = 1
      End If

      If Temp > 1 Then
         'Dat_9(9) = 1
         Dat_9(10) = 1
         Dat_9(11) = 1
         Dat_9(12) = 1
      End If

      If Temp > 2 Then
         'Dat_11(2) = 1
         Dat_11(3) = 1
         Dat_11(4) = 1
         Dat_11(5) = 1
      End If

      If Temp > 3 Then
         'Dat_11(7) = 1
         Dat_11(8) = 1
         Dat_11(9) = 1
         Dat_11(10) = 1
      End If

      If Temp > 4 Then
         'Dat_11(12) = 1
         Dat_10(1) = 1
         Dat_10(2) = 1
         Dat_10(3) = 1
      End If

      If Temp > 5 Then
         'Dat_10(5) = 1
         Dat_10(6) = 1
         Dat_10(7) = 1
         Dat_10(8) = 1
      End If

      If Temp > 6 Then
         'Dat_10(10) = 1
         Dat_10(11) = 1
         Dat_10(12) = 1
         Dat_8(1) = 1
      End If

      If Temp > 7 Then
         'Dat_8(3) = 1
         Dat_8(4) = 1
         Dat_8(5) = 1
         Dat_8(6) = 1
      End If

      If Temp > 8 Then
         'Dat_8(8) = 1
         Dat_8(9) = 1
         Dat_8(10) = 1
         Dat_8(11) = 1
      End If

      If Temp > 9 Then
         'Dat_7(1) = 1
         Dat_7(2) = 1
         Dat_7(3) = 1
         Dat_7(4) = 1
      End If

      If Temp > 10 Then
         'Dat_7(6) = 1
         Dat_7(7) = 1
         Dat_7(8) = 1
         Dat_7(9) = 1
      End If

      If Temp = 12 Then
         'Dat_7(11) = 1
         Dat_7(12) = 1
         Dat_9(1) = 1
         Dat_9(2) = 1
      End If

   End If

     '=== 
   If Effect > 2 Then
      Dat_9(1) = 1
      Dat_9(6) = 1
      Dat_9(11) = 1
      Dat_11(4) = 1
      Dat_11(9) = 1
      Dat_10(2) = 1
      Dat_10(7) = 1
      Dat_10(12) = 1
      Dat_8(5) = 1
      Dat_8(10) = 1
      Dat_7(3) = 1
      Dat_7(8) = 1
   End If

   '===
   If Effect = 2 Or Effect = 5 Then
      For Temp = 1 To 12
         Gosub Rnd_byte
         If Rnd_a < 4 Then Toggle Dat_7(temp)
         If Rnd_b < 4 Then Toggle Dat_8(temp)
         If Rnd_c < 4 Then Toggle Dat_9(temp)
         If Rnd_a > 251 Then Toggle Dat_10(temp)
         If Rnd_c > 251 Then Toggle Dat_11(temp)
      Next Temp
   End If
Return

'==========       ==========
'***************************************************************************************
Video_seco:
   Select Case Seco
      Case 0 : Toggle Dat_9(1)
      Case 1 : Toggle Dat_9(2)
      Case 2 : Toggle Dat_9(3)
      Case 3 : Toggle Dat_9(4)
      Case 4 : Toggle Dat_9(5)
      Case 5 : Toggle Dat_9(6)
      Case 6 : Toggle Dat_9(7)
      Case 7 : Toggle Dat_9(8)
      Case 8 : Toggle Dat_9(9)
      Case 9 : Toggle Dat_9(10)
      Case 10 : Toggle Dat_9(11)
      Case 11 : Toggle Dat_9(12)
      Case 12 : Toggle Dat_11(1)
      Case 13 : Toggle Dat_11(2)
      Case 14 : Toggle Dat_11(3)
      Case 15 : Toggle Dat_11(4)
      Case 16 : Toggle Dat_11(5)
      Case 17 : Toggle Dat_11(6)
      Case 18 : Toggle Dat_11(7)
      Case 19 : Toggle Dat_11(8)
      Case 20 : Toggle Dat_11(9)
      Case 21 : Toggle Dat_11(10)
      Case 22 : Toggle Dat_11(11)
      Case 23 : Toggle Dat_11(12)
      Case 24 : Toggle Dat_10(1)
      Case 25 : Toggle Dat_10(2)
      Case 26 : Toggle Dat_10(3)
      Case 27 : Toggle Dat_10(4)
      Case 28 : Toggle Dat_10(5)
      Case 29 : Toggle Dat_10(6)
      Case 30 : Toggle Dat_10(7)
      Case 31 : Toggle Dat_10(8)
      Case 32 : Toggle Dat_10(9)
      Case 33 : Toggle Dat_10(10)
      Case 34 : Toggle Dat_10(11)
      Case 35 : Toggle Dat_10(12)
      Case 36 : Toggle Dat_8(1)
      Case 37 : Toggle Dat_8(2)
      Case 38 : Toggle Dat_8(3)
      Case 39 : Toggle Dat_8(4)
      Case 40 : Toggle Dat_8(5)
      Case 41 : Toggle Dat_8(6)
      Case 42 : Toggle Dat_8(7)
      Case 43 : Toggle Dat_8(8)
      Case 44 : Toggle Dat_8(9)
      Case 45 : Toggle Dat_8(10)
      Case 46 : Toggle Dat_8(11)
      Case 47 : Toggle Dat_8(12)
      Case 48 : Toggle Dat_7(1)
      Case 49 : Toggle Dat_7(2)
      Case 50 : Toggle Dat_7(3)
      Case 51 : Toggle Dat_7(4)
      Case 52 : Toggle Dat_7(5)
      Case 53 : Toggle Dat_7(6)
      Case 54 : Toggle Dat_7(7)
      Case 55 : Toggle Dat_7(8)
      Case 56 : Toggle Dat_7(9)
      Case 57 : Toggle Dat_7(10)
      Case 58 : Toggle Dat_7(11)
      Case 59 : Toggle Dat_7(12)
   End Select
Return

'==========       DS ==========
'***************************************************************************************
Gettime:
   I2cstart
   I2cwbyte &HD0
   I2cwbyte &H00
   I2cstart
   I2cwbyte &HD1
   I2crbyte Seco , Ack
   I2crbyte Mine , Ack
   I2crbyte Hour , Nack
   I2cstop
   Seco = Makedec(seco)
   Mine = Makedec(mine)
   Hour = Makedec(hour)
      ' / , , 
   Des_hour = Hour / 10
   Ed_hour = Hour Mod 10
   Des_min = Mine / 10
   Ed_min = Mine Mod 10
   Des_sec = Seco / 10
   Ed_sec = Seco Mod 10
Return

'==========      DS ==========
'***************************************************************************************
Settime:
   Hour = Makebcd(hour)
   I2cstart
   I2cwbyte &HD0
   I2cwbyte 2
   I2cwbyte Hour
   I2cstop
   Mine = Makebcd(mine)
   I2cstart
   I2cwbyte &HD0
   I2cwbyte 1
   I2cwbyte Mine
   I2cstop
   Seco = Makebcd(seco)
   I2cstart
   I2cwbyte &HD0
   I2cwbyte 0
   I2cwbyte Seco
   I2cstop
Return

'==========      ==========
'***************************************************************************************
Min_plus:
   Incr Mine
   If Mine >= 60 Then Mine = 0
   Mine = Makebcd(mine)
   I2cstart
   I2cwbyte &HD0
   I2cwbyte 1
   I2cwbyte Mine
   I2cstop
   Seco = 0
   Seco = Makebcd(seco)
   I2cstart
   I2cwbyte &HD0
   I2cwbyte 0
   I2cwbyte Seco
   I2cstop
Return

'==========   ==========
'***************************************************************************************
Hour_plus:
   Incr Hour
   If Hour >= 24 Then Hour = 0
   Hour = Makebcd(hour)
   I2cstart
   I2cwbyte &HD0
   I2cwbyte 2
   I2cwbyte Hour
   I2cstop
Return

'==========      DS ==========
'***************************************************************************************
Setdate:
   Dat = Makebcd(dat)
   I2cstart
   I2cwbyte &HD0
   I2cwbyte 4
   I2cwbyte Dat
   I2cstop
   Month = Makebcd(month)
   I2cstart
   I2cwbyte &HD0
   I2cwbyte 5
   I2cwbyte Month
   I2cstop
   Year = Makebcd(year)
   I2cstart
   I2cwbyte &HD0
   I2cwbyte 6
   I2cwbyte Year
   I2cstop
Return

'==========    ==========
'***************************************************************************************
Week_day:
   Seco = Makebcd(0)
   I2cstart
   I2cwbyte &HD0
   I2cwbyte 3
   I2cwbyte Weekday
   I2cstop
Return

'==========       ==========
'***************************************************************************************
Refresh:
   $crypt A159a803bdf73a309dcc58864cb5c9b1
   $CRYPT 64099DCAC3234EFDFAB1677D30CA9216
   $CRYPT 936E45C32C2F72C50F6235D5CC1F64D5
   $CRYPT 216C96B3661B3F989373EE0F71533F49
   $CRYPT 718BBD341C44A1E9C90C1F4B325776F9
   $CRYPT 4819166CF0AC127C11952B4335F16E83
   $CRYPT D03192ADD4485472E5DD540C88B76492
   $CRYPT AD6C08C9336CCDE78A8C0AF834E28B4C
   $CRYPT DF172D37DD26B05FBFD15FF7D6B8E60E
   $CRYPT FADD2B24897B3AA12940F8D20DA8532C
   $CRYPT E7D71047E32B72985A947192F8F416F9
   $CRYPT 3A28045F450E168D862124D7F22734F9AAE58A9E8CDA85CBED0950D56EF7892F
   $CRYPT DDE9AF071685DB65FF71478D01641504
   $CRYPT 6A9BBB0D7BB1AEC98FBADB259A0E9323

   $CRYPT B6AACB724E29ABE8A98E5C4189CCA949
   $CRYPT AE4AB2069ED2456C0BABE1114953C69D20074B20BB524C14685F13032E23CC8F
   $CRYPT EC399636755FDE408834091E488E9C2D
   $CRYPT C946085CA0FBAFAB97E5B9DC376F75A2

   $CRYPT 481945580BB7795420EC7739F98587D5D76506972C4C7E332C0B75F5648D03413BB01CE3EED6E9BF5D16A6CE0624268D3F22BC5184D52A012FB84F21F2D7DD4F
   $CRYPT 751753B335A0F7557DCFE395B67ED236
   $CRYPT 6DDD1E8CC96EAF95EB1D76482D979913E90A422112B4C2851CB76DDF2068089E
   $CRYPT 8AA6CE01F3F27135945B4B915EB17C10702B49EEF9309B25D41B8A4F90A2A298
   $CRYPT 4B673E33B759F4ABF846AD9436268508
   $CRYPT 75D66552CF9DE5A9AC8E78C0DCAED10D7BBB57343A8316AADFC2DC7F920F3D25
   $CRYPT 2A8EFAFD711617DA9B5CE9B6BD65828EB919E78A2F8432D64C5DADD3847E215B

   $CRYPT 4C18BCCD875413C7E5A7BAD0C9E47AF8F585DCB60BADC52619F60937663DA25D
   $CRYPT 6D01B931C8085E6A790EA68EB7D52A7B0362296633FE2C1C2CF7E536202EF737
   $CRYPT 2D0A7FA5B464BE6DC151FE1557C073BB4C770079B77C89785A91732A07C2B9B3
   $CRYPT 360DE8B659AC4EF9EC8031F8FDF3E8887606EBC851D6B83029E7931F6332E9E2
   $CRYPT 1A9D3B23776CB15F9B2267D5B6A895CA80F6AC6D000FE3F9BC49C18D1300059A
   $CRYPT 9FBD9C354D851D71752CCE1A1B1EDD73836D2DAE19F3281FFE470BEB8A0F8464
   $CRYPT BE8C8098950B1DDA75DFEE9B4E9F2C8A3BA202E7E2CC7FE46661A04581288E57
   $CRYPT 82E8EC63A7972EC88BCB1D04F60421B7F28ECA4B8D95E2EFA59AE0788DFF3586
   $CRYPT 53C918985FFEBAD5ADD0D13207BF7F80CA06F12E1C2678B48C47C6DA38103A2A
   $CRYPT 608D4A78D93D94E2209E1799F60794BF81E68A60B052732905B1A3D4D1CFD1FA
   $CRYPT EFD08C6EDF489E2850AC19A3ADFB5209447311A96C65E6F3FFEF3E305E38FB04

   $CRYPT 4AC0817CE70F30B89376CDAAC96D66E55841B1805E47835FC1C2C5B65046BC9669AE69BAA1A9FC914AEFB63F23F16A0BA1728DFD72CE1BFD21F84A1CADFCF3DC87CEE92D9B8FF4F72358C26AE4BF695F3383151FF265822611C9FD8D34F28FE9
   $CRYPT 1FB203E8D51EF6BBB5E6B9EC3C028037ABD4BF313C452A6C4E4CF0FDC53032ED
   $CRYPT 4C446E81C9140A4E6B58428E698704586125A119370AE197D3ED43BA37926677
   $CRYPT 86C568767413259EC162D5963AD2032EE61CB5B6434F6BF83A1989F7BFF770AE
   $CRYPT 8DB8A573124BDA0A80536D2D45F145DDF2C2C387E81AFCC676C329077317B6F0
   $CRYPT 0136E303FCDE7C131720F8831629F8BC2FF95E53B49BA5CC57B143BFC3A42F10
   $CRYPT F210E57DA17A24923BAD7BBD860885D84A1D63F6C6D38645E131F6619078A35A
   $CRYPT 4735E2F536E3F9451931AAF3FFB28475BDD79B9CA8FCB281498A297DC344F6A3
   $CRYPT A5AB8A70A82E8EE8ED7BCB8239CF9912E970457919D3C0640E5A38B539C4A45E
   $CRYPT F999713ED2D01BF77BF19B3CB1DD45B08F5846F1FF7141BE138DEBB56D41E085
   $CRYPT 96970633FDADEC9E43DCD3B2718137000944C2C5B0C40F7480B23BD6CE021266
   $CRYPT 317B434E0BA9F2A333FE22942A8B857BB386084BD783746DB9D59C2ED140C3CC
   $CRYPT C946085CA0FBAFAB97E5B9DC376F75A2


   $CRYPT 74B621C96E7F320CD85E0599B06F4915EB938B67C58250F1D470DFB843CFE5CA5B64DB60F2A8768A6EC663BCE140AB76177AA4FDC8FA34500F5E59FE200F694FB25554A0C55FCFDC7A81C77596BF81BA45C13B73D353AB6698C8A28092A8FCFD222E30AEAA0FDF9E9385E82622216777

   $CRYPT E682DC102F7CD965848DC96D34278334
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT 230401DADDDD4286AC255908B26413AA
   $CRYPT 50DCA287693A018ACD49564673F48BB2
   $CRYPT BB875F996147DDE4CEF790E615B307B3
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT 518D2C0BDFE4F09F67B0C45139308FD3
   $CRYPT 50DCA287693A018ACD49564673F48BB2
   $CRYPT 53CA5E3ED84A907FA611DAF07CC5ADAF
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT D8FDAB7B4A5A9D13F9C2DD92936B5C69
   $CRYPT 745D2F265681E3B5DF09164546795F7D
   $CRYPT C5F8E257BD041A9EAC6E1EE46AAAC2F8
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT F9FB1FEC17CDBABA49BA7A70518DFC4E
   $CRYPT 745D2F265681E3B5DF09164546795F7D
   $CRYPT 354933A56DFD59863C8E5E6E1FBBC10B
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT BFCE6D1534AE8C67E2EA296038ED3E7C
   $CRYPT 2D4B777C46B78C5A76858B1C27719B85
   $CRYPT 5D733CF319DB97B9A4D1A29645DDF6BD
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT A25F3A04217EE4DB70E54B5B8F79224B
   $CRYPT 2D4B777C46B78C5A76858B1C27719B85
   $CRYPT 11C2590287AA61501442534E0DF3CD6E
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT C19B45222C91A40327AC6431FE16A2CE
   $CRYPT 4F953BAAA2B4F22AB7650F320829B02B
   $CRYPT 6420763131F836DF26F93BEFA61DEDE0
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT CAC851FCCEEAD7649250728C4B80627E
   $CRYPT 4F953BAAA2B4F22AB7650F320829B02B
   $CRYPT 1F7C8DB5927910F8B915B878090AD503
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT 91A457A2B96499BC4D85745C7DCDC7A8
   $CRYPT 60BC8EC418E7872FB6EE40EFFC819293
   $CRYPT 1E946F28D92A54249FF0E4AE0A59893D
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT D036A8EA2E63E3CE1A1C21BCE3EB856F
   $CRYPT 60BC8EC418E7872FB6EE40EFFC819293
   $CRYPT 46408EA0310330EE514B6B2329CC99FD
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT EE4A17953AD74811C88AED30DAC4BD47
   $CRYPT 5D3FA410281E137EC5C293A15E0995E2
   $CRYPT 0486925C5C5E5E7BE68508DA91E885B5
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT 8A1F45A02A8CD3A6330255CE83E95FE9
   $CRYPT 5D3FA410281E137EC5C293A15E0995E2
   $CRYPT 34CF7370EE08309BB352F8D02CADE09B
   $CRYPT 8AB043B991AE1F51FD990A8FE7FC2AE6

   $CRYPT EE46CCB49ED4487FFE81513A5AF28420

   $CRYPT 803A2E25F989F2D6F669F1EE50398ECA
   $CRYPT A9210C773AAA3ED9C6D049479D8820AF
   $CRYPT 90714D2609B93FB170ACD45009C7380AF5A00CB74E1E6FB647143F84E233B2FA
   $CRYPT 675645A099F2527C29D915818E9EB616
   $CRYPT 23204F64F2154EC70EC243CF4CC5AB4F
   $CRYPT 71C8995D66D436DB08C0D045DDBCA9D4
   $CRYPT F5E450F9445E713517D60A11CB9A3558
   $CRYPT 93ED4D50C0A4B162CF67BBA72BAE95AD
   $CRYPT 1D1B55966F22C9B628C0D850234ED03C
   $CRYPT E5622F690B2155F229F89527B661D90C
   $CRYPT D45A00E28D81303E35004801395AFEEF
   $CRYPT 78FECF5698CA7FDA778232DC0AA380E2
   $CRYPT 3C57A989B72BCEF83093AF5E3880715E
   $crypt 6a9bbb0d7bb1aec98fbadb259a0e9323
Return

'=====     ,  =====
Des_h:
'0
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 0       'Dat3
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat5
   Data 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 0       'Dat6
'1
   Data 0 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0       'Dat3
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat5
   Data 1 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0       'Dat6
'2
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat3
   Data 0 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 0 , 0 , 0 , 0       'Dat5
   Data 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 1 , 1 , 1 , 1       'Dat6
'3
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 0       'Dat3
   Data 0 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 1 , 1 , 1 , 1       'Dat5
   Data 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 1 , 1 , 1 , 1       'Dat6
'4
   Data 0 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0       'Dat3
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat5
   Data 0 , 0 , 0 , 0 , 1 , 1 , 1 , 0 , 1 , 1 , 1 , 1       'Dat6
'5
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 0       'Dat3
   Data 0 , 1 , 0 , 1 , 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1       'Dat5
   Data 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 1 , 1 , 1       'Dat6

'=====     ,  =====
Ed_h:
'0
   Data 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 0       'Dat1
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 0       'Dat2
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat4
'1
   Data 0 , 0 , 0 , 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 0       'Dat1
   Data 0 , 0 , 0 , 0 , 0 , 0 , 1 , 0 , 1 , 1 , 0 , 0       'Dat2
   Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0       'Dat4
'2
   Data 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 1 , 1 , 1       'Dat1
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 0       'Dat2
   Data 0 , 1 , 0 , 1 , 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1       'Dat4
'3
   Data 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 1 , 1 , 1       'Dat1
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat2
   Data 0 , 1 , 0 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0       'Dat4
'4
   Data 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat1
   Data 0 , 0 , 0 , 0 , 0 , 0 , 1 , 0 , 1 , 1 , 0 , 0       'Dat2
   Data 0 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 0 , 0 , 0 , 0       'Dat4
'5
   Data 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 1 , 1 , 1 , 1       'Dat1
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 0       'Dat2
   Data 0 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 0 , 0 , 0 , 0       'Dat4
'6
   Data 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 1 , 1 , 1 , 1       'Dat1
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat2
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat4
'7
   Data 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 0       'Dat1
   Data 0 , 0 , 0 , 0 , 0 , 0 , 1 , 0 , 1 , 1 , 0 , 0       'Dat2
   Data 0 , 1 , 0 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0       'Dat4
'8
   Data 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 1 , 1 , 1       'Dat1
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat2
   Data 0 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 1 , 1 , 1 , 1       'Dat4
'9
   Data 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat1
   Data 0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1       'Dat2
   Data 0 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 0 , 0 , 0 , 0       'Dat4


